program carrier
  implicit none
  integer,save::DSpin=1,nskip=0
  real*8,save::T=300.0d0
  integer i,j,nnb,ii,IIOS,nk,NN1,NN2,nb,i_last
  real*8 a1,a2,a3,a4,x,a10,a20,a30
  real*8,allocatable::k(:),eu(:,:),ed(:,:)
  real*8,allocatable::popu(:,:),popd(:,:)
  integer,allocatable::Ikqz(:)
  real*8,parameter::PI=3.14159265359d0
  real*8 Ef,E_holes_u,E_holes_d,E_elec_u,E_elec_d
  real*8,external::FDirac
  real*8 Nelec,Nelec_L,Dmod,CG,Ef_L
  real*8 Ne,NELECT,NET,NEfrac
  integer NKB
  character*200 Buffer,Butt,AAA
  integer,external::trim_count

  if(IARGC()>0) then
      CALL GETARG(1,AAA)
      read(AAA,*,iostat=IIOS)T
      if(IIOS/=0) print *,"you can input a temperature"
  else
      print *,"you can input a temperature"
  endif
  print *

  open(100,file='EIGENVAL',status='old',iostat=IIOS)
    IF(IIOS/=0)THEN
      print *,"EIGENVAL not found" ; STOP
    ENDIF
    read(100,*); read(100,*); read(100,*); read(100,*); read(100,*); read(100,*); read(100,*); read(100,*)
    read(100,"(A)")AAA
    if(trim_count(AAA)<4) DSpin=0
  close(100)
  IF(DSpin==1) print *,"detected: spin-polarized"
  IF(DSpin==0) print *,"detected:spin-unpolarized or spin-orbit coupling"
  print *

  open(100,file='IBZKPT',status='old',iostat=IIOS)
  if(IIOS/=0)open(100,file='KPOINTS',status='old',iostat=IIOS)
  IF(IIOS/=0)THEN
    print *,"IBZKPT or KPOINTS not found" ; STOP
  ENDIF
  read(100,*); read(100,*)nk; read(100,*)
  allocate(Ikqz(nk))
  do i=1,nk
    read(100,*)a1,a2,a3,Ikqz(i)
  enddo
  close(100)

  open(100,file="EIGENVAL")
  do i=1,5
	read(100,*)
  enddo
  read(100,*) NN1,NN2,nb
  print "(i6,a)",nb," bands found"
  read(100,*)
  allocate(k(nk),eu(nb,nk),ed(nb,nk))
  allocate(popu(nb,nk),popd(nb,nk))
  k=0.0d0; a1 =0.0d0; a2 =0.0d0; a3 =0.0d0
           a10=0.0d0; a20=0.0d0; a30=0.0d0
!###################### read OUTCAR #############################
  Ef=0.0d0
  open(123,file="OUTCAR",status='old',iostat=IIOS)
  IF(IIOS/=0)THEN
    print *,"OUTCAR not found" ; STOP
  ENDIF
  do while(IIOS==0)
    read(123,"(a200)",iostat=IIOS)Buffer
    if(Buffer(4:4)=='N'.and.Buffer(5:5)=='E'.and.&
        &Buffer(6:6)=='L'.and.Buffer(7:7)=='E'.and.&
        &Buffer(8:8)=='C'.and.Buffer(9:9)=='T') read(Buffer(12:50),*)NELECT
    if(Buffer(1:1)==' '.and.Buffer(2:2)=='E'.and.&
        &Buffer(3:3)=='-'.and.Buffer(4:4)=='f'.and.&
        &Buffer(5:5)=='e'.and.Buffer(6:6)=='r') read(Buffer(11:50),*)Ef
  enddo
  close(123)
!###################### print ###################################
  NKB = 0
  do i=1,nk
    NKB = NKB + Ikqz(i)
  enddo
  NET=NELECT*NKB
!######################  checking data #####################
  E_holes_u=0.0d0 ; E_holes_d=0.0d0
  E_elec_u=0.0d0 ; E_elec_d=0.0d0
  do i=1,nk
	read(100,*)a1,a2,a3,a4
	!!!k(i)=a3
    if(Ikqz(i)==0.AND.nskip==0)then
      a10=a1; a20=a2; a30=a3
      nskip=1; i_last=i
    endif

    if(Ikqz(i)==0)then
      k(i)=k(i_last)+sqrt((a1-a10)**2+(a2-a20)**2+(a3-a30)**2)
      i_last=i
    endif
    a10=a1; a20=a2; a30=a3

	do j=1,nb
      if(DSpin==0)then
		read(100,*)nnb,eu(nnb,i)
        popu(nnb,i)=FDirac(eu(nnb,i),Ef,T)
        if(popu(nnb,i)>0.5d0)then
            E_holes_u=E_holes_u+Ikqz(i)*(1.0d0-popu(nnb,i))
        else
            E_elec_u=E_elec_u+Ikqz(i)*popu(nnb,i)
        endif
      else
		read(100,*)nnb,eu(nnb,i),ed(nnb,i)
        popu(nnb,i)=FDirac(eu(nnb,i),Ef,T)
        popd(nnb,i)=FDirac(ed(nnb,i),Ef,T)
        if(popu(nnb,i)>0.5d0)then
            E_holes_u=E_holes_u+Ikqz(i)*(1.0d0-popu(nnb,i))
        else
            E_elec_u=E_elec_u+Ikqz(i)*popu(nnb,i)
        endif
        
        if(popd(nnb,i)>0.5d0)then
            E_holes_d=E_holes_d+Ikqz(i)*(1.0d0-popd(nnb,i))
        else
            E_elec_d=E_elec_d+Ikqz(i)*popd(nnb,i)
        endif

      endif
    enddo
  enddo

  Ne=0.0d0
  do i=1,nnb
    do j=1,nk
      if(DSpin==0)then
        Ne=Ne+Ikqz(j)*2*FDirac(eu(i,j),Ef,T)
      else
        Ne=Ne+Ikqz(j)*(FDirac(eu(i,j),Ef,T)+FDirac(ed(i,j),Ef,T))
      endif
    enddo
  enddo
  NEfrac=Ne/NET
  IF(NEfrac>1.95.AND.NEfrac<2.05d0)THEN
    print *
    print *,"###########################################"
    print *,"     it looks like a SOC calculation!"
    print *,"###########################################"
    NET=NET*2.0d0 ; DSpin=0
  ELSE IF(NEfrac<0.95d0.OR.NEfrac>1.05d0)THEN
    print *,"electron number not fit" ; print *,"I'm confused!!!!!" ; STOP
  ENDIF
  print *
  print "(a10,f12.5)"," NELECT = ",NELECT
  print "(i4,a15)",NKB," k-points found"
  print "(a7,f12.5,a)"," Total:",NET," electrons"
  print *
  print *,"original:"
  print *,"    E-fermi:",Ef
  print *,"    calculated electron number:",Ne
!################################################################
  Nelec_L=0.0d0
  do i=1,nnb
    do j=1,nk
      if(DSpin==0)then
        Nelec_L=Nelec_L+Ikqz(j)*2*FDirac(eu(i,j),Ef,T)
      else
        Nelec_L=Nelec_L+Ikqz(j)*(FDirac(eu(i,j),Ef,T)+FDirac(ed(i,j),Ef,T))
      endif
    enddo
  enddo
  Nelec_L=Nelec_L-NET

  Dmod=0.001d0
  do ii=1,100
    Ef=Ef+Dmod ; Nelec=0.0d0
    do i=1,nnb
      do j=1,nk
        if(DSpin==0)then
          Nelec=Nelec+Ikqz(j)*2*FDirac(eu(i,j),Ef,T)
        else
          Nelec=Nelec+Ikqz(j)*(FDirac(eu(i,j),Ef,T)+FDirac(ed(i,j),Ef,T))
        endif
      enddo
    enddo
    Nelec=Nelec-NET

    CG=(Nelec-Nelec_L)/Dmod ; Dmod=-Nelec/CG
    if(abs(Dmod)<1.0d-8.OR.abs(Nelec-Nelec_L)<1.0d-90) exit
    Nelec_L=Nelec ; Ef_L=Ef
  enddo

  print *
  print *,"E-fermi adjusted:"
  print "(a13,f8.2,a2)","     temperature:",T," K"
  print *,"    E-fermi:",Ef
  Ne=0.0d0
  do i=1,nnb
    do j=1,nk
      if(DSpin==0)then
        Ne=Ne+Ikqz(j)*2*FDirac(eu(i,j),Ef,T)
      else
        Ne=Ne+Ikqz(j)*(FDirac(eu(i,j),Ef,T)+FDirac(ed(i,j),Ef,T))
      endif
    enddo
  enddo
  print *,"    calculated electron number:",Ne

  E_holes_u=0.0d0 ; E_holes_d=0.0d0
  E_elec_u=0.0d0 ; E_elec_d=0.0d0
  do i=1,nnb
    do j=1,nk
      if(DSpin==0)then
        popu(i,j)=FDirac(eu(i,j),Ef,T)
        if(popu(i,j)>0.5d0)then
            E_holes_u=E_holes_u+Ikqz(j)*(1.0d0-popu(i,j))
        else
            E_elec_u=E_elec_u+Ikqz(j)*popu(i,j)
        endif
      else
        popu(i,j)=FDirac(eu(i,j),Ef,T)
        popd(i,j)=FDirac(ed(i,j),Ef,T)
        if(popu(i,j)>0.5d0)then
            E_holes_u=E_holes_u+Ikqz(j)*(1.0d0-popu(i,j))
        else
            E_elec_u=E_elec_u+Ikqz(j)*popu(i,j)
        endif

        if(ed(i,j) > Ef-0.10) cycle
        if(popd(i,j)>0.5d0)then
            E_holes_d=E_holes_d+Ikqz(j)*(1.0d0-popd(i,j))
        else
            E_elec_d=E_elec_d+Ikqz(j)*popd(i,j)
        endif
      endif
    enddo
  enddo

  print *
  print *,"carrier number:"
  IF(DSpin>0)THEN
    print *,"holes:    ",E_holes_u,E_holes_d
  ELSE
    print *,"holes:    ",E_holes_u
  ENDIF
end program carrier
!###################################################
real*8 function FDirac(E,Ef,T)
  real*8 E,Ef,T
  real*8,parameter::kb=8.617d-5

  FDirac=1.0d0/(exp((E-Ef)/Kb/T)+1.0d0)
end function FDirac
!###########################################
integer function trim_count(AAA)
  character*(*) AAA
  integer i,ist,ist_last

  trim_count=0
  ist=0 ; ist_last=0
  do i=1,len_trim(AAA)
    ist_last=ist
    if(AAA(i:i)/=' ') ist=1
    if(AAA(i:i)==' ') ist=0
    if(ist_last==1.AND.ist==0) trim_count=trim_count+1
  enddo
end function trim_count